Index: /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.cpp	(revision 504)
+++ /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.cpp	(revision 504)
@@ -0,0 +1,184 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+  This program is free software; you can redistribute it and/or modify it
+  under the terms of the GNU General Public License as published by the Free
+  Software Foundation; either version 2 of the License, or (at your option)
+  any later version.
+
+  This program is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+  more details.
+
+  You should have received a copy of the GNU General Public License along with
+  this program; if not, write to the Free Software Foundation, Inc., 59
+  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+
+  The full GNU General Public License is included in this distribution in the
+  file called LICENSE.
+*******************************************************************************/
+#include "indiusbdevice.h"
+
+#include <string.h>
+
+INDI::USBDevice::USBDevice()
+{
+	dev=NULL;
+	usb_handle=NULL;
+	OutputEndpoint=0;
+	InputEndpoint=0;
+
+	usb_init();
+	usb_find_busses();
+	usb_find_devices();
+}
+
+
+INDI::USBDevice::~USBDevice()
+{
+}
+
+struct usb_device * INDI::USBDevice::FindDevice(int vendor, int product, int searchindex)
+{
+    struct usb_device *dev;
+    struct usb_bus *usb_bus;
+    int index=0;
+
+    for(usb_bus=usb_busses; usb_bus; usb_bus=usb_bus->next) {
+        for(dev=usb_bus->devices; dev; dev=dev->next) {
+            if(dev->descriptor.idVendor==vendor) {
+                if(dev->descriptor.idProduct==product) {
+                    if(index==searchindex) {
+                        fprintf(stderr,"Device has %d configurations\n",dev->descriptor.bNumConfigurations);
+                        return dev;
+                    }
+                    else index++;
+                }
+            }
+        }
+    }
+    return NULL;
+
+}
+
+int INDI::USBDevice::Open()
+{
+	if(dev==NULL) return -1;
+
+	usb_handle=usb_open(dev);
+	if(usb_handle != NULL) {
+		//printf("Opened ok\n");
+
+		return FindEndpoints();
+		//return 0;
+	}
+	return -1;
+}
+
+int INDI::USBDevice::FindEndpoints()
+{
+
+	int rc=0;
+	struct usb_interface_descriptor *intf;
+
+
+
+	intf=&dev->config[0].interface[0].altsetting[0];
+	for(int i=0; i<intf->bNumEndpoints; i++) {
+		fprintf(stderr,"%04x %04x\n",
+			   intf->endpoint[i].bEndpointAddress,
+			   intf->endpoint[i].bmAttributes
+			   );
+
+		int dir;
+		int addr;
+		addr=intf->endpoint[i].bEndpointAddress;
+		addr = addr & (USB_ENDPOINT_DIR_MASK^0xffff);
+		//printf("%02x ",addr);
+
+		int attr;
+		int tp;
+		attr=intf->endpoint[i].bmAttributes;
+		tp=attr&USB_ENDPOINT_TYPE_MASK;
+		//if(tp==USB_ENDPOINT_TYPE_BULK) printf("Bulk  ");
+		//if(tp==USB_ENDPOINT_TYPE_INTERRUPT) printf("Interrupt ");
+
+
+
+		dir=intf->endpoint[i].bEndpointAddress;
+		dir=dir&USB_ENDPOINT_DIR_MASK;
+		if(dir==USB_ENDPOINT_IN) {
+			//printf("Input  ");
+			fprintf(stderr,"Got an input endpoint\n");
+			InputEndpoint=addr;
+			InputType=tp;
+		}
+		if(dir==USB_ENDPOINT_OUT) {
+			//printf("Output ");
+			fprintf(stderr,"got an output endpoint\n");
+			OutputEndpoint=addr;
+			OutputType=tp;
+		}
+		//printf("\n");
+	}
+
+	//printf("claim interface returns %d\n",rc);
+	return rc;
+
+}
+
+int INDI::USBDevice::ReadInterrupt(char *buf,int c,int timeout)
+{
+	int rc;
+
+	rc=usb_interrupt_read(usb_handle,InputEndpoint,buf,c,timeout);
+	//rc=usb_bulk_read(usb_handle,InputEndpoint,buf,c,timeout);
+	return rc;
+
+}
+
+int INDI::USBDevice::WriteInterrupt(char *buf,int c,int timeout)
+{
+	int rc;
+
+	//printf("Writing %02x to endpoint %d\n",buf[0],OutputEndpoint);
+	rc=usb_interrupt_write(usb_handle,OutputEndpoint,buf,c,timeout);
+	return rc;
+
+}
+
+int INDI::USBDevice::ReadBulk(char *buf,int c,int timeout)
+{
+	int rc;
+
+	//rc=usb_interrupt_read(usb_handle,InputEndpoint,buf,c,timeout);
+	rc=usb_bulk_read(usb_handle,InputEndpoint,buf,c,timeout);
+	return rc;
+
+}
+
+int INDI::USBDevice::WriteBulk(char *buf,int c,int timeout)
+{
+	int rc;
+
+	//printf("Writing %02x to endpoint %d\n",buf[0],OutputEndpoint);
+	//rc=usb_interrupt_write(usb_handle,OutputEndpoint,buf,c,timeout);
+	rc=usb_bulk_write(usb_handle,OutputEndpoint,buf,c,timeout);
+	return rc;
+
+}
+
+int INDI::USBDevice::ControlMessage()
+{
+    char buf[3];
+    int rc;
+
+    buf[0]=0;
+    buf[1]=0;
+    buf[2]=0;
+
+    rc=usb_control_msg(usb_handle,0xc2&USB_ENDPOINT_IN, 0x12,0,0,buf,3,1000);
+    fprintf(stderr,"UsbControlMessage returns %d\n",rc);
+    return 0;
+}
Index: /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.h	(revision 504)
+++ /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.h	(revision 504)
@@ -0,0 +1,67 @@
+/*******************************************************************************
+  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+
+  This program is free software; you can redistribute it and/or modify it
+  under the terms of the GNU General Public License as published by the Free
+  Software Foundation; either version 2 of the License, or (at your option)
+  any later version.
+
+  This program is distributed in the hope that it will be useful, but WITHOUT
+  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
+  more details.
+
+  You should have received a copy of the GNU General Public License along with
+  this program; if not, write to the Free Software Foundation, Inc., 59
+  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
+
+  The full GNU General Public License is included in this distribution in the
+  file called LICENSE.
+*******************************************************************************/
+
+#ifndef USBDEVICE_H
+#define USBDEVICE_H
+
+#pragma once
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <unistd.h>
+#include <errno.h>
+
+#include <usb.h>
+
+#include "indibase.h"
+
+class INDI::USBDevice
+{
+protected:
+	struct usb_device *dev;
+	struct usb_dev_handle *usb_handle;
+
+	int ProductId;
+	int VendorId;
+
+	int OutputType;
+	int OutputEndpoint;
+	int InputType;
+	int InputEndpoint;
+
+	struct usb_device * FindDevice(int,int,int);
+
+public:
+	int WriteInterrupt(char *,int,int);
+	int ReadInterrupt(char *,int,int);
+
+	int ControlMessage();
+
+	int WriteBulk(char *,int,int);
+	int ReadBulk(char *,int,int);
+	int FindEndpoints();
+	int Open();
+        USBDevice(void);
+        USBDevice(struct usb_device *);
+        virtual ~USBDevice(void);
+};
+
+#endif // USBDEVICE_H
Index: /BAORadio/libindi/libindi/libs/indicom.c
===================================================================
--- /BAORadio/libindi/libindi/libs/indicom.c	(revision 503)
+++ /BAORadio/libindi/libindi/libs/indicom.c	(revision 504)
@@ -34,5 +34,5 @@
 #include <sys/param.h>
 
-//#include <config.h>
+#include <config.h>
 
 #ifdef HAVE_NOVA_H
@@ -248,4 +248,7 @@
 int tty_timeout(int fd, int timeout)
 {
+ if (fd == -1)
+        return TTY_ERRNO;
+
   struct timeval tv;
   fd_set readout;
@@ -276,4 +279,7 @@
 int tty_write(int fd, const char * buf, int nbytes, int *nbytes_written)
 {
+    if (fd == -1)
+           return TTY_ERRNO;
+
   int bytes_w = 0;   
   *nbytes_written = 0;
@@ -297,4 +303,7 @@
 int tty_write_string(int fd, const char * buf, int *nbytes_written)
 {
+    if (fd == -1)
+           return TTY_ERRNO;
+
   unsigned int nbytes;
   int bytes_w = 0;
@@ -321,4 +330,6 @@
 int tty_read(int fd, char *buf, int nbytes, int timeout, int *nbytes_read)
 {
+    if (fd == -1)
+           return TTY_ERRNO;
 
  int bytesRead = 0;
@@ -349,4 +360,6 @@
 int tty_read_section(int fd, char *buf, char stop_char, int timeout, int *nbytes_read)
 {
+    if (fd == -1)
+           return TTY_ERRNO;
 
  int bytesRead = 0;
@@ -496,5 +509,5 @@
                         break;
                 default:
-                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid bit rate.", bit_rate)  0)
+                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid bit rate.", bit_rate) < 0)
                                 perror(NULL);
                         else
@@ -521,5 +534,5 @@
 
                         fprintf( stderr, "Default\n") ;
-                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid data bit count.", word_size)  0)
+                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid data bit count.", word_size) < 0)
                                 perror(NULL);
                         else
@@ -542,5 +555,5 @@
 
                         fprintf( stderr, "Default1\n") ;
-                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid parity selection value.", parity)  0)
+                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid parity selection value.", parity) < 0)
                                 perror(NULL);
                         else
@@ -559,5 +572,5 @@
                 default:
                         fprintf( stderr, "Default2\n") ;
-                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid stop bit count.", stop_bits)  0)
+                        if (snprintf(msg, sizeof(msg), "tty_connect: %d is not a valid stop bit count.", stop_bits) < 0)
                                 perror(NULL);
                         else
@@ -651,4 +664,5 @@
     {
         close(t_fd);
+        *fd = -1;
     }
 
@@ -662,5 +676,5 @@
 
 #else
- int t_fd=0;
+ int t_fd=-1;
  char msg[80];
  int bps;
@@ -668,5 +682,8 @@
 
  if ( (t_fd = open(device, O_RDWR | O_NOCTTY )) == -1)
+ {
+     *fd = -1;
     return TTY_PORT_FAILURE;
+ }
 
     /* Control Modes
@@ -853,4 +870,7 @@
 int tty_disconnect(int fd)
 {
+    if (fd == -1)
+           return TTY_ERRNO;
+
 #ifdef _WIN32
 	return TTY_ERRNO;
Index: /BAORadio/libindi/libindi/tools/setINDIproperty.c
===================================================================
--- /BAORadio/libindi/libindi/tools/setINDIproperty.c	(revision 503)
+++ /BAORadio/libindi/libindi/tools/setINDIproperty.c	(revision 504)
@@ -71,5 +71,7 @@
 static int readServerChar (FILE *fp);
 static void findSet (XMLEle *root, FILE *fp);
-static void scanEV (SetSpec *sp, char e[], char v[]);
+static void scanEV (SetSpec *specp, char ev[]);
+static void scanEEVV (SetSpec *specp, char *ep, char ev[]);
+static void scanEVEV (SetSpec *specp, char ev[]);
 static void sendNew (FILE *fp, INDIDef *dp, SetSpec *sp);
 static void sendSpecs(FILE *wfp);
@@ -205,7 +207,6 @@
 {
 	fprintf(stderr, "Purpose: set one or more writable INDI properties\n");
-	fprintf(stderr, "%s\n", "$Revision: 1.4 $");
-	fprintf(stderr, "Usage: %s [options] {[type] device.property.e1[;e2...]=v1[;v2...]} ...\n",
-									    me);
+	fprintf(stderr, "%s\n", "$Revision: 1.6 $");
+	fprintf(stderr, "Usage: %s [options] {[type] spec} ...\n", me);
 	fprintf(stderr, "Options:\n");
 	fprintf(stderr, "  -d f  : use file descriptor f already open to server\n");
@@ -213,6 +214,6 @@
 	fprintf(stderr, "  -p p  : alternate port, default is %d\n", INDIPORT);
 	fprintf(stderr, "  -t t  : max time to wait, default is %d secs\n",TIMEOUT);
-	fprintf(stderr, "  -v    : verbose (cumulative)\n");
-	fprintf(stderr, "Each property optionally preceded by its type is sent without first confirming\n");
+	fprintf(stderr, "  -v    : verbose (more are cumulative)\n");
+	fprintf(stderr, "Each spec optionally preceded by its type is sent without first confirming\n");
 	fprintf(stderr, "its structure. This is much more efficient but there is no error checking.\n");
 	fprintf(stderr, "Types are indicated with the following flags:\n");
@@ -220,4 +221,8 @@
 	fprintf(stderr, "  -n    : Number\n");
 	fprintf(stderr, "  -s    : Switch\n");
+	fprintf(stderr, "Spec may be either:\n");
+	fprintf(stderr, "    device.property.e1[;e2...]=v1[;v2...]\n");
+	fprintf(stderr, "  or\n");
+	fprintf(stderr, "    device.property.e1=v1[;e2=v2...]\n");
 	fprintf(stderr, "Exit status:\n");
 	fprintf(stderr, "  0: all settings successful\n");
@@ -234,5 +239,5 @@
 crackSpec (int *acp, char **avp[])
 {
-	char d[1024], p[1024], e[2048], v[2048];
+	char d[128], p[128], ev[2048];
 	char *spec = *avp[0];
 	INDIDef *dp = NULL;
@@ -254,6 +259,6 @@
 
 	/* then scan arg for property spec */
-	if (sscanf (spec, "%[^.].%[^.].%[^.=]=%s", d, p, e, v) != 4) {
-	    fprintf (stderr, "Bad property format: %s\n", spec);
+	if (sscanf (spec, "%[^.].%[^.].%s", d, p, ev) != 3) {
+	    fprintf (stderr, "Malformed property spec: %s\n", spec);
 	    usage();
 	}
@@ -268,5 +273,5 @@
 	sets[nsets].ev = (SetEV *) malloc (1);		/* seed realloc */
 	sets[nsets].nev = 0;
-	scanEV (&sets[nsets++], e, v);
+	scanEV (&sets[nsets++], ev);
 
 	/* update caller's pointers */
@@ -466,30 +471,57 @@
 }
 
-/* scan e1[;e2...] v1[;v2,...] from e[] and v[] and add to spec sp.
+/* scan ev for element definitions in either of two forms and add to sp:
+ *    e1[;e2...]=v1[;v2...]
+ *  or
+ *    e1=v1[;e2=v2...]
+ * exit if nothing sensible found.
+ */
+static void
+scanEV (SetSpec *specp, char ev[])
+{
+	char *ep, *sp;		/* pointers to = and ; */
+
+	if (verbose > 1)
+	    fprintf (stderr, "Scanning assignments %s\n", ev);
+
+	ep = strchr (ev, '=');
+	sp = strchr (ev, ';');
+
+	if (!ep) {
+	    fprintf (stderr, "Malformed assignment: %s\n", ev);
+	    usage();
+	}
+
+	if (sp < ep)
+	    scanEEVV (specp, ep, ev);	/* including just one E=V */
+	else
+	    scanEVEV (specp, ev);
+}
+
+/* add specs of the form e1[;e2...]=v1[;v2...] to sp.
+ * v is pointer to equal sign.
  * exit if trouble.
- */
-static void
-scanEV (SetSpec *sp, char e[], char v[])
+ * N.B. e[] and v[] are modified in place.
+ */
+static void
+scanEEVV (SetSpec *sp, char *v, char *e)
 {
 	static char sep[] = ";";
-	char *ep, *vp;
-
-	if (verbose > 1)
-	    fprintf (stderr, "Scanning %s = %s\n", e, v);
+	char *ec, *vc;
+
+	*v++ = '\0';
 
 	while (1) {
-	    char *e0 = strtok_r (e, sep, &ep);
-	    char *v0 = strtok_r (v, sep, &vp);
+	    char *e0 = strtok_r (e, sep, &ec);
+	    char *v0 = strtok_r (v, sep, &vc);
 
 	    if (!e0 && !v0)
 		break;
 	    if (!e0) {
-		fprintf (stderr, "More values than elements for %s.%s\n",
-								sp->d, sp->p);
+		fprintf (stderr, "More values than elements for %s.%s\n", sp->d, sp->p);
 		exit(2);
 	    }
 	    if (!v0) {
-		fprintf (stderr, "More elements than values for %s.%s\n",
-								sp->d, sp->p);
+		fprintf (stderr, "More elements than values for %s.%s\n", sp->d, sp->p);
 		exit(2);
 	    }
@@ -498,4 +530,6 @@
 	    sp->ev[sp->nev].e = strcpy (malloc(strlen(e0)+1), e0);
 	    sp->ev[sp->nev].v = strcpy (malloc(strlen(v0)+1), v0);
+	    if (verbose > 1)
+		fprintf (stderr, "Found assignment %s=%s\n", sp->ev[sp->nev].e, sp->ev[sp->nev].v);
 	    sp->nev++;
 
@@ -503,4 +537,42 @@
 	    v = NULL;
 	}
+}
+
+/* add specs of the form e1=v1[;e2=v2...] to sp.
+ * exit if trouble.
+ * N.B. ev[] is modified in place.
+ */
+static void
+scanEVEV (SetSpec *sp, char ev[])
+{
+	char *s, *e;
+	int last = 0;
+
+	do {
+	    s = strchr (ev, ';');
+	    if (s)
+		*s++ = '\0';
+	    else {
+		s = ev + strlen (ev);
+		last = 1;
+	    }
+	    e = strchr (ev, '=');
+	    if (e)
+		*e++ = '\0';
+	    else {
+		fprintf (stderr, "Malformed assignment: %s\n", ev);
+		usage();
+	    }
+
+	    sp->ev = (SetEV *) realloc (sp->ev, (sp->nev+1)*sizeof(SetEV));
+	    sp->ev[sp->nev].e = strcpy (malloc(strlen(ev)+1), ev);
+	    sp->ev[sp->nev].v = strcpy (malloc(strlen(e)+1), e);
+	    if (verbose > 1)
+		fprintf (stderr, "Found assignment %s=%s\n", sp->ev[sp->nev].e, sp->ev[sp->nev].v);
+	    sp->nev++;
+
+	    ev = s;
+
+	} while (!last);
 }
 
@@ -517,3 +589,3 @@
 
 /* For RCS Only -- Do Not Edit */
-static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: setINDI.c,v $ $Date: 2007/10/11 20:12:11 $ $Revision: 1.4 $ $Name:  $"};
+static char *rcsid[2] = {(char *)rcsid, "@(#) $RCSfile: setINDI.c,v $ $Date: 2010/11/07 07:13:59 $ $Revision: 1.6 $ $Name:  $"};
